// ForbiddenPointsView.cpp : implementation of the CForbiddenPointsView class
//

#include "stdafx.h"
#include "ForbiddenPoints.h"

#include "ForbiddenPointsDoc.h"
#include "ForbiddenPointsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CForbiddenPointsView

IMPLEMENT_DYNCREATE(CForbiddenPointsView, CFormView)

BEGIN_MESSAGE_MAP(CForbiddenPointsView, CFormView)
	//{{AFX_MSG_MAP(CForbiddenPointsView)
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDM_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CForbiddenPointsView construction/destruction

CForbiddenPointsView::CForbiddenPointsView()
	: CFormView(CForbiddenPointsView::IDD)
{
	//{{AFX_DATA_INIT(CForbiddenPointsView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	nCurrent = 0;
	nTotal = 0;
	finder.Clear();
}

CForbiddenPointsView::~CForbiddenPointsView()
{
}

void CForbiddenPointsView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CForbiddenPointsView)
	//}}AFX_DATA_MAP
}

BOOL CForbiddenPointsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CForbiddenPointsView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	//GetParentFrame()->RecalcLayout();
	//ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CForbiddenPointsView diagnostics

#ifdef _DEBUG
void CForbiddenPointsView::AssertValid() const
{
	CFormView::AssertValid();
}

void CForbiddenPointsView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CForbiddenPointsDoc* CForbiddenPointsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CForbiddenPointsDoc)));
	return (CForbiddenPointsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CForbiddenPointsView message handlers

void CForbiddenPointsView::OnDraw(CDC* pDC) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CRect rectClient;
	GetClientRect(rectClient);

	int nBoardWidth;
	if (rectClient.Width() >= rectClient.Height())
	{
		nBoardWidth = rectClient.Height();
	}
	else
	{
		nBoardWidth = rectClient.Width();
	}

	//m_richeditBoard.MoveWindow(nBoardWidth+10, 10, rectClient.Width()-nBoardWidth-20, rectClient.Width()-nBoardWidth-20);

	int grid = nBoardWidth / 17;
	CBrush*	pBrush = new CBrush(RGB(220,180,120));
	pDC->FillRect(CRect((int)(grid*1.3), (int)(grid*.3), (int)(grid * 16.7), (int)(grid * 15.7)), pBrush);
	delete pBrush;

	CPen* pPen = new CPen(PS_SOLID, 1, RGB(0,0,0));
	CBrush* pBrushLine = new CBrush(RGB(0,0,0));
	CPen* pOldPen = pDC->SelectObject(pPen);
	CBrush* pOldBrush = pDC->SelectObject(pBrushLine);
	for (int i=1; i<=15; i++)
	{
		pDC->MoveTo(grid+grid, grid*i);
		pDC->LineTo(grid*15+grid, grid*i);
		pDC->MoveTo(grid*i+grid, grid);
		pDC->LineTo(grid*i+grid, grid*15);
	}

	pDC->Ellipse(grid*4+grid-grid/6, grid*4-grid/6, grid*4+grid+grid/6, grid*4+grid/6);
	pDC->Ellipse(grid*4+grid-grid/6, grid*12-grid/6, grid*4+grid+grid/6, grid*12+grid/6);
	pDC->Ellipse(grid*12+grid-grid/6, grid*4-grid/6, grid*12+grid+grid/6, grid*4+grid/6);
	pDC->Ellipse(grid*12+grid-grid/6, grid*12-grid/6, grid*12+grid+grid/6, grid*12+grid/6);
	pDC->Ellipse(grid*8+grid-grid/6, grid*8-grid/6, grid*8+grid+grid/6, grid*8+grid/6);
	
	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
	delete pPen;
	delete pBrushLine;

	CFont*	pNewFont1=new CFont;
	pNewFont1->CreatePointFont((int)(grid*4.5),"Arial",pDC);
	CFont*	pNewFont2=new CFont;
	pNewFont2->CreatePointFont((int)(grid*3),"Arial",pDC);
	CFont*	pOldFont = (CFont *)pDC->SelectObject(pNewFont1);
	pDC->SetTextAlign(TA_CENTER);
	pDC->SetTextColor(RGB(0,0,127));
	pDC->SetBkColor(GetSysColor(COLOR_BTNFACE));

	for(i=1; i<=15; i++)
	{
		CString	strTemp;
		strTemp.Format("%C", 'A'+i-1);
		pDC->TextOut(grid*i+grid, (int)(grid*15.8), strTemp);
		strTemp.Format("%d", 16-i);
		pDC->TextOut((int)(grid*.7), (int)(grid*(i-.3)), strTemp);
	}

	pDC->SelectObject(pNewFont2);
	
	if (nCurrent > 0)
	{
		for (i=1; i<=nCurrent; i++)
		{
			if (i % 2 == 1)
			{
				pDC->SelectStockObject(BLACK_BRUSH);
				pDC->SelectStockObject(BLACK_PEN);
				pDC->SetTextColor(RGB(255,255,255));
				pDC->SetBkColor(RGB(0,0,0));
			}
			else
			{
				pDC->SelectStockObject(WHITE_BRUSH);
				pDC->SelectStockObject(WHITE_PEN);
				pDC->SetTextColor(RGB(0,0,0));
				pDC->SetBkColor(RGB(255,255,255));
			}
			int x = listStone[i-1].x;
			int y = listStone[i-1].y;
			pDC->Ellipse((int)(grid*x-grid*.45+grid), (int)(grid*y-grid*.45), (int)(grid*x+grid*.45+grid), (int)(grid*y+grid*.45));

			CString	strTemp;
			strTemp.Format("%d", i);
			if (i == nCurrent)
				pDC->SetBkColor(RGB(220,180,120));
			pDC->TextOut(grid*x+grid, (int)(grid*(y-.25)), strTemp);
		}
	}

	pDC->SelectObject(pOldFont);
	delete pNewFont1;
	delete pNewFont2;

	// Draw forbidden points
	if (finder.nForbiddenPoints > 0)
	{
		CPen* pPen = new CPen(PS_SOLID, 2, RGB(255,0,0));
		CPen* pOldPen = pDC->SelectObject(pPen);
		for (i=0; i<finder.nForbiddenPoints; i++)
		{
			int x = finder.ptForbidden[i].x + 1;
			int y = finder.ptForbidden[i].y + 1;
			pDC->MoveTo((int)(grid*x-grid*.3+grid+1), (int)(grid*y-grid*.3+1));
			pDC->LineTo((int)(grid*x+grid*.3+grid+1), (int)(grid*y+grid*.3+1));
			pDC->MoveTo((int)(grid*x-grid*.3+grid+1), (int)(grid*y+grid*.3+1));
			pDC->LineTo((int)(grid*x+grid*.3+grid+1), (int)(grid*y-grid*.3+1));
		}
		pDC->SelectObject(pOldPen);
		delete pPen;
	}
}

void CForbiddenPointsView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDC* pDC = GetDC();
	CRect rect;
	GetClientRect(&rect);

	int	cx = rect.Width();
	int cy = rect.Height();

	if (cx > cy)
		cx = cy;
	else
		cy = cx;
	
	int grid = cx / 17;
		
	if ((point.x >= grid/2+grid) && (point.x <= grid*15+grid/2+grid) &&
		(point.y >= grid/2) && (point.y <= grid*15+grid/2))
	{
		int x = (point.x - grid/2 - grid) / grid + 1;
		int y = (point.y - grid/2) / grid + 1;
	
		BOOL bExist = FALSE;
		for (int m=0; m<nCurrent; m++)
		{
			if ((listStone[m].x == x) &&
				(listStone[m].y == y))
			{
				bExist = TRUE;
				break;
			}
		}
		if (!bExist)
		{
			CString strMove;
			strMove.Format("%C%C", 'A'+(x-1), 'A'+(15-y));
			MakeMove(strMove);
		}
	}

	CFormView::OnLButtonUp(nFlags, point);
}

void CForbiddenPointsView::MakeMove(CString strMove)
{
	CDC* pDC = GetDC();
	CRect rect;
	GetClientRect(&rect);

	int	cx = rect.Width();
	int cy = rect.Height();

	if (cx > cy)
		cx = cy;
	else
		cy = cx;
	
	int grid = cx / 17;

		
	int x = strMove[0] - 'A' + 1;
	int y = 15 - (strMove[1] - 'A');
		
	nCurrent++;
	nTotal = nCurrent;
	listStone[nCurrent-1].x = x;
	listStone[nCurrent-1].y = y;
	InvalidateRect(CRect((int)(grid*x-grid*.45+grid), (int)(grid*y-grid*.45), (int)(grid*x+grid*.45+grid), (int)(grid*y+grid*.45)), FALSE);	
	int nF;
	CPoint fP[BOARDSIZE * BOARDSIZE];
	if (finder.nForbiddenPoints > 0)
	{
		nF = finder.nForbiddenPoints;
		for (int i=0; i<nF; i++)
		{
			fP[i].x = finder.ptForbidden[i].x;
			fP[i].y = finder.ptForbidden[i].y;
		}
	}
	
	int nResult = finder.AddStone(x-1, y-1, (nCurrent%2) ? BLACKSTONE : WHITESTONE);
	switch (nResult)
	{
	case 0:
		AfxMessageBox("Black Five In a Row!");
		break;
	case 1:
		AfxMessageBox("White Five In a Row!");
		break;
	case 2:
		AfxMessageBox("Black Forbidden Move!");
		break;
	default:
		break;
	}
	//finder.cBoard[x][y] = (nCurrent%2) ? BLACKSTONE : WHITESTONE;
	//UpdateTextBoard();
	//finder.FindForbiddenPoints();
	//if (finder.IsDoubleThree(8, 8))
	//	AfxMessageBox("H8 is a black 3x3!");
	//if (finder.IsDoubleFour(0, 14))
	//	AfxMessageBox("H8 is a black 4x4!");
		
	if (nCurrent > 1)
	{
		int x = listStone[nCurrent-2].x;
		int y = listStone[nCurrent-2].y;
		InvalidateRect(CRect((int)(grid*x-grid*.45+grid), (int)(grid*y-grid*.45), (int)(grid*x+grid*.45+grid), (int)(grid*y+grid*.45)), FALSE);
	}

	if (nF > 0)
	{
		for (int i=0; i<nF; i++)
		{
			int x = fP[i].x + 1;
			int y = fP[i].y + 1;
			InvalidateRect(CRect((int)(grid*x+grid*.5), (int)(grid*y-grid*.5), (int)(grid*x+grid*1.5), (int)(grid*y+grid*.5)), FALSE);
		}
	}

	for (int i=0; i<finder.nForbiddenPoints; i++)
	{
		int x = finder.ptForbidden[i].x + 1;
		int y = finder.ptForbidden[i].y + 1;
		InvalidateRect(CRect((int)(grid*x+grid*.5), (int)(grid*y-grid*.5), (int)(grid*x+grid*1.5), (int)(grid*y+grid*.5)), FALSE);
	}
}

void CForbiddenPointsView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDC* pDC = GetDC();
	CRect rect;
	GetClientRect(&rect);

	int	cx = rect.Width();
	int cy = rect.Height();

	if (cx > cy)
		cx = cy;
	else
		cy = cx;

	int grid = cx / 17;

	if ((point.x >= grid/2+grid) && (point.x <= grid*159+grid/2+grid) &&
		(point.y >= grid/2) && (point.y <= grid*15+grid/2) &&
		(nCurrent >= 1))
	{
		nCurrent--;
			
		int x = listStone[nCurrent].x;
		int y = listStone[nCurrent].y;
		InvalidateRect(CRect((int)(grid*x-grid*.45+grid), (int)(grid*y-grid*.45), (int)(grid*x+grid*.45+grid), (int)(grid*y+grid*.45)), FALSE);
		int nF;
		CPoint fP[BOARDSIZE * BOARDSIZE];
		if (finder.nForbiddenPoints > 0)
		{
			nF = finder.nForbiddenPoints;
			for (int i=0; i<nF; i++)
			{
				fP[i].x = finder.ptForbidden[i].x;
				fP[i].y = finder.ptForbidden[i].y;
			}
		}
		finder.AddStone(x-1, y-1, EMPTYSTONE);
		//UpdateTextBoard();
		//finder.FindForbiddenPoints();
		if (nCurrent > 0)
		{
			x = listStone[nCurrent-1].x;
			y = listStone[nCurrent-1].y;
			InvalidateRect(CRect((int)(grid*x-grid*.45+grid), (int)(grid*y-grid*.45), (int)(grid*x+grid*.45+grid), (int)(grid*y+grid*.45)), FALSE);
		}
		for (int i=0; i<nF; i++)
		{
			int x = fP[i].x + 1;
			int y = fP[i].y + 1;
			InvalidateRect(CRect((int)(grid*x+grid*.5), (int)(grid*y-grid*.5), (int)(grid*x+grid*1.5), (int)(grid*y+grid*.5)), FALSE);
		}
		for (i=0; i<finder.nForbiddenPoints; i++)
		{
			x = finder.ptForbidden[i].x + 1;
			y = finder.ptForbidden[i].y + 1;
			InvalidateRect(CRect((int)(grid*x+grid*.5), (int)(grid*y-grid*.5), (int)(grid*x+grid*1.5), (int)(grid*y+grid*.5)), FALSE);
		}
	}
		
	CFormView::OnRButtonUp(nFlags, point);
}

void CForbiddenPointsView::OnClear() 
{
	// TODO: Add your command handler code here
	nCurrent = 0;
	nTotal = 0;
	InvalidateRect(NULL);
	finder.Clear();
	//UpdateTextBoard();
}

/*void CForbiddenPointsView::UpdateTextBoard()
{
	//////////////////
	CHARFORMAT	cf;
	cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_BOLD|CFM_ITALIC|CFM_COLOR|CFM_FACE|CFM_SIZE;//|CFM_UNDERLINE|CFM_STRIKEOUT|CFM_SIZE|
		//CFM_COLOR|CFM_OFFSET|CFM_PROTECTED;
	cf.dwEffects = 0;
	cf.crTextColor = RGB(0,0,0);
	lstrcpy(cf.szFaceName, "Courier");
	cf.yHeight = 200;
	cf.bCharSet = 0;
	cf.bPitchAndFamily = 0;//DEFAULT_PITCH | FF_DONTCARE;
	
	UpdateData(TRUE);
	char strTemp[400];
	int idx=0;
	for (int j=0; j<17; j++)
	{
		for (int i=0; i<17; i++)
			strTemp[idx++] = finder.cBoard[i][j];
		strTemp[idx++] = '\r';
		strTemp[idx++] = '\n';
	}
	strTemp[idx++] = '\0';
	m_richeditBoard.SetSel(0, -1);
	m_richeditBoard.SetSelectionCharFormat(cf);
	m_richeditBoard.ReplaceSel(CString(strTemp));
	UpdateData(FALSE);
	//////////////////
}*/
